.plugin asm86

#include "Seklorea/tools/RBP2.inc"

.org $D748

 nop
 jp ProgStart
.dw 2,Title,Icon

Title:
.db "Sound Tutorial",0

Icon:
.db 8,1 ; for the old skool proggies support :-(
.db %00001111
.db %00001111
.db %00011000
.db %00011000
.db %00011000
.db %01111000
.db %11111000
.db %01110000
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %10001111
.db %11111111

Setup2:
 call vdisplay
 jp _getkey
 
ProgStart:
 call EXIT
 call _flushallmenus
 call _runindicoff
 set textInverse,(iy+textflags)
 ld hl,Spaces
 ld bc,$0000
 call display
 res textInverse,(iy+textflags)
 ld hl,MainText
 ld bc,$0002
 call display
; ld c,$03
 inc c
 call display
; ld c,$04
 inc c
 call display
; ld c,$05
 inc c
 call display
KEYLOOP:
 call _getkey
 cp k1
 jr z,TUTOR
 cp k2
 jr z,SOURCE
 cp k3
 jr z,SAMPLE
 cp k4
 jr z,EXIT
 jr KEYLOOP

TUTOR:
 call _clrLCD
 ld hl,TTEXT1
 ld bc,$0000
 push bc
 ld a,8
 call page1
 ld hl,TTEXT2
 pop bc
 ld a,7
 call page1
 jr ProgStart
 
SOURCE:
 ld hl,STEXT1
 ld bc,$0000
 ld a,8
 call PageSave
 call PageSave
 call PageSave
 call PageSave
 ld a,7
 call page1
 jr ProgStart

PageSave:
 push bc
 push af
 call page1
 pop af
 pop bc
 ret
display:
 ld (_curRow),bc
 jp _puts

vdisplay:
 ld (_penCol),bc
 jp _vputs
 
EXIT:
 call _clrLCD
 jp _homeup
 
SAMPLE:
 ld hl,Sound
PlayWAV:
 di ; greylib by robert taylor can't be used :(
 ld a,0C0h   
 out (7),a
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld b,128 ; b is used as a mask
SoundLoop:
 ld c,19
DLoop:
 dec c
 jr nz,DLoop
 call NOPS
 rrc b
 jr nc,Play
 inc hl ;next byte
 dec de
 ld a,d
 or e
 jr z,DonePlay
Play:
 ld a,(hl) ; get bit
 and b
 jr z,Play1
 ld a,0FCh
 call NOPS
 out (7),a
 jr SoundLoop
Play1:
 ld a,0C0h
 out (7),a
 jr SoundLoop
DonePlay:
 ld a,0C0h
 call NOPS
 out (7),a
 ei
 jp ProgStart

NOPS:
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 ret

page1:
 push hl
 push bc
 push af
 call EXIT
 pop af
 pop bc
 pop hl
Loop:
 push af
 call vdisplay
 ld a,8
 add a,b
 ld b,a
 pop af
 dec a
 jr nz,Loop
 push hl
 call _getkey
 pop hl
 ret

Spaces:
.db "   Sound  Tutorial   "
.db "    William White    ",0
 
MainText:
.db "1.Tutorial",0
.db "2.Useful Source",0
.db "3.Sample,by me",0
.db "4.Exit",0

TTEXT1:
.db "Use WAV2DB that I included & read",0
.db "the help file & convert a song",0
.db "or write your own sound code in",0
.db "HEX.Read the source I included",0
.db "in this program. HEX uses 0,1,2,3,",0
.db "4,5,6,7,8,9,A,B,C,D,E,F.Use any",0
.db "combo of 2 for each byte,up to 8",0
.db "bytes,i.e. here is a beep--",0
TTEXT2:
.db ".db $FF,$EE,$DD,$CC,$33,$22",0
.db "Use Assembly Studio 8x to make",0
.db "the programs & edit sound HEX.In",0
.db "HEX,0=highest pitch & F=lowest.3.5",0
.db "mm-2.5mm headphone adapter can be",0
.db "found at Radioshack to put in the",0
.db "linkport to listen with headphones.",0

STEXT1: 
.db "PlayWAV:",0
.db " di",0
.db " ld a,$C0",0
.db " out (7),a",0
.db " ld e,(hl)",0
.db " inc hl",0
.db " ld d,(hl)",0
.db " inc hl",0
.db " ld b,128",0
.db "SoundLoop:",0
.db " ld c,19",0
.db "DLoop:",0
.db " dec c",0
.db " jr nz,DLoop",0
.db " nop",0
.db " nop",0
.db " rrc b",0
.db " jr nc,Play",0
.db " inc hl",0
.db " dec de",0
.db " ld a,d",0
.db " or e",0
.db " jr z,DonePlay",0
.db "Play:",0
.db " ld a,(hl)",0
.db " and b",0
.db " jr z,Play1",0
.db " ld a,$FC",0
.db " out (7),a",0
.db " jr SoundLoop",0
.db "Play1:",0
.db " ld a,$C0",0
.db " out (7),a",0
.db " jr SoundLoop",0
.db "DonePlay:",0
.db " ld a,$C0",0
.db " out (7),a",0
.db " ei",0
.db " ret",0
 
Sound:
.dw 1424
.db $03,$FF,$FF,$FF,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$00,$00,$7F
.db $FF,$FF,$E0,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$C0,$00,$3F,$FF,$FF
.db $F0,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$E0,$00,$1F,$FF,$FF,$F8,$00
.db $00,$00,$0F,$FF,$FF,$FF,$FF,$F0,$00,$0F,$FF,$FF,$F8,$00,$00,$00
.db $0F,$FF,$FF,$FF,$FF,$C0,$00,$07,$FF,$FF,$FC,$00,$00,$00,$1F,$FF
.db $FF,$FF,$FF,$F0,$00,$07,$FF,$FF,$FF,$00,$00,$00,$1F,$FF,$FF,$FF
.db $FF,$FF,$00,$00,$7F,$FF,$FF,$F0,$00,$00,$03,$FF,$FF,$FF,$FF,$FF
.db $F8,$00,$0F,$FF,$FF,$FE,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FE,$01
.db $FF,$FF,$C0,$0D,$FF,$FC,$73,$1C,$E4,$63,$1F,$FF,$FE,$E7,$0B,$8E
.db $C6,$FC,$00,$77,$DE,$62,$00,$0D,$EF,$59,$CE,$31,$FF,$FC,$00,$1F
.db $FF,$E0,$00,$FF,$80,$61,$9E,$00,$FF,$F0,$00,$7F,$F8,$03,$FF,$C0
.db $01,$FE,$C3,$9C,$1F,$FF,$80,$0F,$FE,$01,$FF,$E0,$07,$F0,$00,$63
.db $F0,$0F,$FE,$00,$3F,$E0,$0F,$FE,$00,$FF,$00,$27,$F0,$F8,$87,$FF
.db $00,$7F,$00,$7F,$E0,$7F,$C0,$20,$00,$78,$3E,$00,$FF,$00,$3F,$80
.db $7F,$C0,$7F,$80,$F8,$02,$0D,$07,$C0,$7F,$C0,$0F,$C0,$1F,$E0,$1F
.db $C0,$3F,$01,$06,$D0,$7C,$07,$FE,$03,$FC,$03,$FE,$03,$FC,$03,$F0
.db $01,$27,$03,$E0,$7F,$F0,$0F,$F0,$3F,$F0,$3F,$E0,$3F,$00,$00,$18
.db $DF,$81,$FF,$80,$7F,$80,$FF,$C0,$FF,$80,$F8,$00,$40,$03,$3F,$0F
.db $FE,$00,$FC,$03,$FE,$0F,$FC,$03,$E0,$03,$0C,$47,$81,$FF,$C0,$1F
.db $C0,$3F,$F0,$FF,$C0,$1F,$00,$0E,$0C,$7E,$1F,$FC,$00,$FC,$01,$FF
.db $03,$FC,$03,$E0,$02,$C3,$0F,$87,$FF,$80,$0F,$C0,$1F,$FE,$3F,$19
.db $80,$01,$80,$E3,$F1,$FF,$E0,$00,$7F,$FF,$FF,$FF,$E0,$00,$38,$20
.db $41,$C7,$CF,$9F,$FF,$C0,$00,$1F,$FF,$FF,$F0,$00,$00,$1F,$F0,$FF
.db $FF,$FF,$FF,$E0,$00,$3F,$FF,$FF,$C0,$00,$00,$00,$07,$FF,$FF,$F0
.db $7F,$F8,$00,$31,$FF,$FF,$FF,$E0,$00,$00,$00,$1F,$FF,$FF,$FE,$03
.db $FE,$00,$3F,$CF,$FF,$FF,$FF,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF
.db $00,$07,$7F,$FF,$FF,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$C0,$01,$FE
.db $03,$FF,$FF,$FF,$FF,$C0,$00,$00,$07,$FF,$FF,$FF,$FF,$80,$1F,$FF
.db $87,$C0,$7F,$FF,$FF,$80,$00,$00,$01,$FF,$FF,$FF,$FF,$E0,$00,$2F
.db $FF,$07,$BF,$9F,$FF,$BF,$20,$00,$00,$3F,$FF,$FF,$81,$FF,$F8,$00
.db $0F,$FF,$FF,$F0,$00,$1B,$00,$08,$0F,$F7,$FF,$FE,$00,$07,$FF,$FE
.db $00,$00,$1E,$40,$02,$0F,$FF,$FF,$FC,$00,$0F,$FF,$F8,$00,$00,$00
.db $00,$00,$81,$FD,$FF,$FF,$00,$03,$FF,$FF,$0F,$FF,$00,$00,$F8,$1C
.db $0F,$E7,$FF,$F0,$00,$7F,$FF,$27,$FF,$80,$0F,$D0,$00,$60,$78,$3F
.db $FE,$00,$1F,$F9,$0F,$FF,$E0,$07,$F0,$06,$01,$83,$E0,$FF,$F8,$00
.db $FF,$F0,$3F,$FF,$C0,$0E,$F0,$03,$83,$C3,$E3,$07,$FA,$00,$FF,$E0
.db $BF,$FF,$E0,$32,$18,$00,$E1,$61,$F8,$C3,$FF,$80,$07,$FF,$FF,$FF
.db $F4,$00,$00,$00,$3C,$76,$1F,$F8,$3F,$F8,$00,$7F,$FF,$FF,$FF,$80
.db $06,$00,$01,$BE,$C7,$FF,$03,$FF,$00,$30,$FB,$E7,$FF,$FC,$00,$00
.db $02,$71,$F7,$E7,$FF,$8F,$CF,$FE,$80,$61,$FF,$FF,$BF,$79,$00,$40
.db $17,$DF,$FF,$FF,$B7,$0C,$22,$5D,$05,$78,$59,$B2,$8E,$D9,$46,$C3
.db $5A,$BA,$DB,$DB,$76,$DD,$DE,$CB,$65,$75,$49,$54,$9B,$26,$D9,$B5
.db $6C,$A3,$5E,$96,$9A,$CD,$B2,$C9,$B7,$5B,$69,$BB,$54,$95,$69,$92
.db $56,$5B,$4A,$CD,$B4,$92,$5E,$DB,$92,$E9,$4B,$25,$A4,$96,$B6,$95
.db $77,$55,$A5,$55,$6D,$64,$DA,$56,$AB,$6D,$55,$59,$2D,$69,$B6,$C9
.db $B4,$A9,$55,$D6,$69,$2D,$56,$D9,$6B,$5A,$6D,$25,$A5,$52,$96,$D6
.db $B7,$AD,$36,$C8,$96,$FD,$B6,$C8,$93,$2D,$BB,$26,$B4,$A6,$6D,$BE
.db $97,$74,$BD,$D9,$A5,$EB,$43,$D7,$76,$F9,$B6,$C9,$0E,$DA,$8B,$7F
.db $FF,$6D,$11,$2D,$EF,$F6,$BE,$BF,$FF,$25,$7F,$FE,$00,$1F,$FF,$FF
.db $1F,$90,$0F,$FC,$00,$07,$FF,$FF,$FF,$FE,$00,$00,$E3,$E0,$07,$FF
.db $C0,$03,$FF,$F7,$BF,$FF,$00,$00,$C7,$0F,$C0,$3F,$FF,$00,$0F,$FF
.db $FF,$FF,$FE,$00,$00,$05,$8F,$FE,$DF,$FF,$FF,$00,$FF,$FF,$FF,$FE
.db $80,$00,$00,$01,$FF,$FA,$FF,$FF,$80,$01,$7F,$FF,$FF,$C8,$00,$00
.db $03,$FF,$FF,$FF,$FF,$FC,$00,$03,$FF,$FF,$FC,$00,$00,$00,$1F,$FF
.db $FF,$FF,$FF,$F0,$00,$3F,$FF,$FF,$FA,$00,$00,$00,$3F,$FF,$FF,$FF
.db $C0,$00,$1F,$FF,$FF,$F8,$00,$00,$00,$3F,$FF,$FF,$FF,$F8,$00,$0F
.db $FF,$FF,$F8,$00,$00,$00,$3F,$FF,$FF,$FF,$F8,$00,$1F,$FF,$FF,$FE
.db $00,$00,$10,$FF,$FF,$FF,$FE,$00,$01,$FF,$FF,$FF,$80,$00,$03,$07
.db $C0,$FF,$F0,$1F,$00,$1F,$FF,$FF,$80,$00,$00,$1E,$1E,$00,$7F,$98
.db $3E,$00,$7F,$FF,$FE,$00,$00,$04,$70,$F0,$C3,$FF,$83,$E1,$83,$FF
.db $FF,$FE,$00,$00,$11,$C3,$C7,$0F,$FE,$0F,$80,$0F,$FF,$FF,$F0,$00
.db $00,$03,$C7,$86,$1F,$FC,$0F,$98,$1F,$FF,$FF,$F0,$00,$00,$03,$C3
.db $C3,$0F,$FE,$07,$8E,$0F,$FF,$FF,$FC,$00,$00,$00,$78,$F8,$E1,$FF
.db $81,$F9,$C1,$FF,$FF,$FF,$80,$00,$00,$0F,$87,$C2,$1F,$F8,$0F,$80
.db $0F,$FF,$FF,$C0,$00,$00,$0F,$0F,$0F,$C0,$1F,$F8,$0F,$E0,$07,$FF
.db $9F,$FC,$00,$00,$00,$01,$F1,$F8,$43,$FF,$01,$F8,$01,$FF,$FF,$FF
.db $83,$80,$00,$3F,$FF,$F1,$F8,$03,$FE,$01,$FC,$00,$FF,$FF,$FC,$00
.db $38,$00,$1F,$BF,$FF,$1F,$00,$3F,$C0,$1F,$80,$1F,$FF,$0F,$F4,$00
.db $3C,$01,$FF,$FF,$FF,$1F,$00,$3F,$80,$1F,$1C,$1F,$FF,$FF,$FB,$06
.db $06,$1E,$1F,$FE,$7F,$70,$F0,$03,$FC,$01,$F0,$03,$FF,$FF,$FE,$00
.db $00,$67,$C7,$FF,$EF,$FC,$3C,$00,$FF,$00,$78,$E1,$FF,$FF,$F3,$87
.db $00,$F0,$07,$FF,$BF,$FF,$E1,$F0,$07,$FC,$01,$C3,$87,$FF,$FF,$E0
.db $0F,$00,$37,$F3,$FF,$C3,$FC,$FC,$3F,$00,$7F,$F0,$00,$F8,$FF,$FF
.db $FF,$E3,$C1,$83,$87,$FF,$FF,$F9,$FF,$FF,$E0,$1F,$FF,$00,$0A,$FF
.db $FF,$FF,$FF,$FE,$80,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$0A,$3E
.db $FB,$FF,$DF,$FF,$FF,$BF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$07,$FF,$8F,$FF,$FF,$FF,$FF,$FF
.db $FB,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$38,$73
.db $EC,$39,$FF,$FF,$FF,$FF,$F7,$FF,$FF,$FF,$E7,$FF,$E9,$E3,$1C,$F1
.db $8E,$FF,$67,$80,$7F,$F6,$7F,$FF,$BC,$DE,$58,$E2,$17,$B5,$8D,$DB
.db $FF,$F2,$13,$DF,$8F,$EF,$7F,$F8,$E7,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $F1,$EF,$D9,$EF,$DE,$7F,$FF,$FF,$FF,$FF,$FF,$EF,$FF,$FF,$FF,$F9
.db $FD,$0F,$FF,$FB,$FF,$C3,$3F,$FF,$C4,$3F,$FF,$FF,$FF,$FD,$80,$00
.db $00,$CF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$BE,$7D,$FF,$E7,$9F,$FF,$FF
.db $FF,$BF,$FF,$FF,$FF,$FF,$E7,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$3F
.db $FF,$FF,$FF,$EF,$3F,$FF,$FF,$FF,$E3,$BD,$0F,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$FF,$FD,$FF,$E3,$FF,$FF,$FF,$FF,$FF,$FF,$CF,$FF
.db $FC,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
.db $FF,$FF,$FF,$FF,$EF,$FF,$67,$FF,$FF,$FF,$FF,$FF,$E7,$FF,$FF,$FF

.end